unit net_threads;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, pingsend;
type
    nThread = class(TThread)
    private
    protected
      procedure Execute; override;
      n_socket: TPingSend;
    public
      Constructor Create(CreateSuspended : boolean);
      host: string;
      tm: integer;
      state: boolean;
      res: string;
      run: boolean;
    end;


implementation


constructor nThread.Create(CreateSuspended : boolean);
begin
  FreeOnTerminate := True;
  inherited Create(CreateSuspended);
end;


procedure nThread.Execute;
begin
run := true;
state := false;
 while (not Terminated) and (run) do begin
    n_socket := TPingSend.Create;
    try
      n_socket.Timeout := tm;
      n_socket.ping(host);
      if n_socket.pingtime <> -1 then begin
        res := host + '|' + IntTostr(n_socket.pingtime) + '|' + inttostr(n_socket.Timeout) + '|' + inttostr(n_socket.TTL);
        state := true;
      end;
    finally
      run := false;
      n_socket.Free;
    end;
 end;
end;

end.

